package com.blamejared.compat.forestry;

import com.blamejared.ModTweaker;
import com.blamejared.mtlib.helpers.InputHelper;
import com.blamejared.mtlib.helpers.LogHelper;
import com.blamejared.mtlib.helpers.StackHelper;
import com.blamejared.mtlib.utils.BaseAddForestry;
import com.blamejared.mtlib.utils.BaseRemoveForestry;
import crafttweaker.annotations.ModOnly;
import crafttweaker.annotations.ZenRegister;
import crafttweaker.api.item.IIngredient;
import crafttweaker.api.item.IItemStack;
import crafttweaker.api.item.WeightedItemStack;
import forestry.api.recipes.ICentrifugeRecipe;
import forestry.api.recipes.RecipeManagers;
import forestry.factory.recipes.CentrifugeRecipe;
import java.util.HashMap;
import java.util.Map;
import net.minecraft.item.ItemStack;
import stanhebben.zenscript.annotations.ZenClass;
import stanhebben.zenscript.annotations.ZenMethod;

@ZenClass("mods.forestry.Centrifuge")
@ModOnly("forestry")
@ZenRegister
public class Centrifuge {
   public static final String name = "Forestry Centrifuge";

   @ZenMethod
   public static void addRecipe(WeightedItemStack[] output, IItemStack ingredients, int packagingTime) {
      Map<ItemStack, Float> products = new HashMap();
      WeightedItemStack[] var4 = output;
      int var5 = output.length;

      for(int var6 = 0; var6 < var5; ++var6) {
         WeightedItemStack product = var4[var6];
         products.put(InputHelper.toStack(product.getStack()), product.getChance());
      }

      ModTweaker.LATE_ADDITIONS.add(new Add(new CentrifugeRecipe(packagingTime, InputHelper.toStack(ingredients), products)));
   }

   @ZenMethod
   public static void removeRecipe(IIngredient input) {
      ModTweaker.LATE_REMOVALS.add(new Remove(input));
   }

   private static class Remove extends BaseRemoveForestry<ICentrifugeRecipe> {
      private IIngredient input;

      public Remove(IIngredient input) {
         super("Forestry Centrifuge", RecipeManagers.centrifugeManager);
         this.input = input;
      }

      protected String getRecipeInfo() {
         return this.input.toString();
      }

      public boolean checkIsRecipe(ICentrifugeRecipe recipe) {
         return recipe != null && StackHelper.matches(this.input, InputHelper.toIItemStack(recipe.getInput()));
      }
   }

   private static class Add extends BaseAddForestry<ICentrifugeRecipe> {
      public Add(ICentrifugeRecipe recipe) {
         super("Forestry Centrifuge", RecipeManagers.centrifugeManager, recipe);
      }

      protected String getRecipeInfo() {
         return LogHelper.getStackDescription(((ICentrifugeRecipe)this.recipe).getInput());
      }
   }
}
